## eccodes 2.22.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
 find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild)
 
 # Initialise project
-project( eccodes VERSION 2.21.0 LANGUAGES C )
+project( eccodes VERSION 2.22.1 LANGUAGES C )
 
 ###############################################################################
 # system checks needed for eccodes_config.h and some options like MEMFS
