=== debian/changelog ===
eccodes (2.22.1-2) unstable; urgency=medium

  * Push to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 16 Aug 2021 04:38:24 +0100

eccodes (2.22.1-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 21 Jun 2021 11:38:18 +0100

eccodes (2.22.0-1) experimental; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 23 May 2021 14:49:58 +0100

eccodes (2.21.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.5.1
  * Move branches in d/gbp.conf to DEP-14 names
  * Point vcs-git to debian/latest branch

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 26 Mar 2021 13:15:42 +0000
